/* Copyright (c) 2003 Andrew Stikheev. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * $Id: base.h,v 1.5 2004/07/31 16:53:04 sand Exp $
 */

#ifndef BASE_H_
#define BASE_H_

#include<sys/param.h>

#define NUM_TYPES 3 

void                    Quit (const char* );
void            	Warn (const char* );

//------------------------------------------------------------------------------
typedef struct
{
        in_addr_t               dstIP;
        u_short                 dstPort;
        u_short                 srcPort;
	time_t			time;
} connectItem;

//------------------------------------------------------------------------------
typedef struct
{
        in_addr_t               srcIP;
        int			weight[NUM_TYPES];
	int			 total[NUM_TYPES];
	connectItem		  *con[NUM_TYPES];
} statisticItem;

//------------------------------------------------------------------------------
typedef struct
{
        int			total;
        statisticItem		*item;
} cluster;
//------------------------------------------------------------------------------
typedef struct
{
	int			numClusters;
	int			clusterSize;
	int			blockIfAny;
	int			enableBlock;
	u_short			divertPort;
	int			maxConnects[NUM_TYPES];
	int 			maxWeight[NUM_TYPES];
	int 			blkWeight[NUM_TYPES];
	int 			minWeight[NUM_TYPES];
	int 			factor[NUM_TYPES][2];
	char			blkFile[PATH_MAX];
	char			blTFile[PATH_MAX];
	char			pidFile[PATH_MAX];
	char			mapFile[PATH_MAX];
	char			logFile[PATH_MAX];
} systemParameters;
//------------------------------------------------------------------------------
typedef struct
{
	unsigned int		readPackets;
	unsigned int		readPacketsFailure;
	unsigned int		writePacketsFailure;
	unsigned int		blockPackets;
} systemVariables;
//------------------------------------------------------------------------------
#endif
