/*
 * Copyright (c) 2003 Andrew Stikheev. All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * $Id: mem.c,v 1.2 2004/04/28 06:04:44 sand Exp $
 */
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include "base.h"
#include "mem.h"

void *InitizializeMemory (	void *mem,
				systemParameters **sys,
				systemVariables **sysV	)
{
        int i,j,t,n = 0 ;
        cluster *c;
        statisticItem *item;
        int memorySize = 0;

	if ( mem == NULL ) return NULL;

	if ( *sys == NULL ) *sys = (systemParameters *)mem;
	else	memcpy( mem, (void *) *sys, sizeof(systemParameters));

	mem += sizeof (systemParameters);

	*sysV = (systemVariables *) mem;
	mem += sizeof (systemVariables);

/*        printf("numClusters  %d\n",(*sys)->numClusters);
        printf("clusterSize  %d\n",(*sys)->clusterSize);
        for(i = 0; i < NUM_TYPES; i++) {
                printf("maxConnects[%d]  %d\n",i,(*sys)->maxConnects[i]);
        }
*/

        for ( j = 0 ; j < NUM_TYPES; j++ ) {
                memorySize += (*sys)->maxConnects[j];
        }
        memorySize *= sizeof(connectItem);
//	printf("memorySize %d\n",memorySize);

        for( i = 0; i < (*sys)->numClusters ; i++ ) {

                c = (cluster *) mem + i;
//		printf("cluster %d addr %d\n",i,(int)c - (int)mem);
                c->item = mem +(*sys)->numClusters * sizeof(cluster) +
                          i * sizeof(statisticItem)  * (*sys)->clusterSize;

                for (j = 0; j < (*sys)->clusterSize ; j++) {

                        item = c->item + j;
//			printf("item %d addr %d\n",j,(int)item - (int)mem);

                        n =     (*sys)->numClusters * ( sizeof(cluster) +
                                sizeof(statisticItem) * (*sys)->clusterSize ) +
                                (i * (*sys)->clusterSize + j) * memorySize;

                        for ( t = 0; t < NUM_TYPES; t++ ) {

                                if ( t > 0) n +=  (*sys)->maxConnects[t-1] *
                                                  sizeof(connectItem);

                                item->con[t] = mem + n;
//				printf("con[%d]  addr %d\n",t,(int)item->con[t] - (int)mem);
                        }
                }
        }
//	printf("shift %d sizeof() %d\n",(int)mem - (int)start, sizeof(systemParameters) + sizeof(systemVariables));
	return mem;
}
